<?php

namespace TVn7\CoreBundle\DependencyInjection;

use Symfony\Component\Config\Definition\Builder\TreeBuilder;
use Symfony\Component\Config\Definition\ConfigurationInterface;

/**
 * This is the class that validates and merges configuration from your app/config files
 *
 * To learn more see {@link http://symfony.com/doc/current/cookbook/bundles/extension.html#cookbook-bundles-extension-config-class}
 */
class Configuration implements ConfigurationInterface
{
    /**
     * {@inheritDoc}
     */
    public function getConfigTreeBuilder()
    {
        $treeBuilder = new TreeBuilder();
        $rootNode = $treeBuilder->root('t_vn7_core');

        $regex = "/^(25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.(25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.(25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.(25[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])(\/(3[0-2]|[0-2]?[0-9]))?$/";

        $rootNode->children()
                    ->arrayNode('allowed_ips')
                        ->prototype('scalar')
                            ->validate()
                                ->ifTrue(function($ip) use ($regex) {
                                    return (preg_match($regex, $ip) == false);
                                })
                                ->thenInvalid("Valid ip or ip range required. %s given.")
                            ->end()
                        ->end()
                    ->end();

        return $treeBuilder;
    }
}
